<?php
/**
 * Plugin Name:       AliansPay - Payment gateway for WooCommerce 
 * Plugin URI:        https://www.alianspay.com/
 * Description:       AliansPay - Payment gateway for WooCommerce is a modern plugin that allows you to sell anywhere your customers are. Give yours customers the gift of mordern payment solution and let them pay you however they want by: Orange Money, MTN Mobile Money, VISA, MASTER CARD and AliansPay wallet.
 * Version:           1.0
 * Author:            Alians Group LLC
 * Author URI:        https://aliansgroup.tech/
 * License:           GPL v2
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain:       alianspay
 */

/**
 * Try to prevent direct access data leaks
 */
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}





/**
 * Check if WooCommerce is present and active
 **/
if ( ! in_array( 'woocommerce/woocommerce.php', 
      apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    return;
}

add_filter( 'woocommerce_payment_gateways', 'alianspay_add_to_woocommerce' );
/**
 * Add the gateway to WooCommerce Available Gateways
 * 
 * @param array $gateways all available WooCommerce gateways
 * @return array $gateways all WooCommerce gateways + alianspay gateway
 */
function alianspay_add_to_woocommerce ( $gateways ) {
    $gateways[] = 'Alianspay_Woocommerce_Gateway';
    return $gateways;
}

add_action( 'plugins_loaded', 'alianspay_gateway_init', 0);

/**
 * Method call when the plugin load
 * @return void 
 */

function alianspay_gateway_init() {
    
if(isset ($_GET["alianspay"])){
	class Alianspay_Woocommerce_Gateway extends WC_Payment_Gateway { }?>
    <form id="dataFormAliansPay" action="<?php echo $_GET["urlalianspay"]; ?>" method="post" target="_top">         
        <input type="hidden" name="brand" value="Mon Panier" />
        <input type="hidden" name="currency" value="<?php echo get_woocommerce_currency(); ?>" /> 
        <input type="hidden" name="amount" value="<?php echo $_GET["totalamount"] ?>" />
        <input type="hidden" name="pin" value="<?php echo $_GET["pin"] ?>" />   
        <input type="hidden" name="purchaseref" value="<?php $json = json_decode($_GET["custom"], true); echo $json['order_id']; ?>" />
        <input type="hidden" name="description"value="<?php echo $_GET["description"]; ?>" />
        <input type="hidden" name="notifurl" value="<?php echo $_GET["notify_url"]; ?>" />
        <input type="hidden" name="accepturl" value="<?php echo $_GET["return"]; ?>" />
        <input type="hidden" name="cancelurl" value="<?php echo $_GET["cancel_return"]; ?>" />
        <input type="hidden" name="declineurl" value="<?php echo $_GET["cancel_return"]; ?>" />
        <input type="hidden" name="callbackurl" value="<?php echo $_GET["callbackurl"]; ?>" /> 
        <input type="hidden" name="text" value="<?php echo $_GET["text"]; ?>" />
        <input type="hidden" name="language" value="<?php echo $_GET["language"]; ?>" /> 
        <input type="hidden" name="urlalianspay" value="<?php echo $_GET["urlalianspay"]; ?>" />
        <input type="hidden" name="token" value="<?php echo $_GET["token"]; ?>" />
        <input type="hidden" name="userkey" value="<?php echo $_GET["userkey"]; ?>" />
        <input type="hidden" name="userpassword" value="<?php echo $_GET["userpassword"]; ?>" />
    </form>
<script type="text/javascript"> 
    document.getElementById('dataFormAliansPay').submit(); /// SUBMIT FORM
  
</script>
		<?php
}
else{

    

	    class Alianspay_Woocommerce_Gateway extends WC_Payment_Gateway {
		const ALIANSPAY_GATEWAY_ID = 'alianspay';
        const ALIANSPAY_API_BASE_URL = 'https://test-alianspay.aliansfi.com/api';
        const ALIANSPAY_API_LOGIN_URL = 'accesstoken/token';
        const ALIANSPAY_API_PAYIN_URL = 'paylink';
        const ALIANSPAY_TRANSACTION_REASON =  'Payment for my items';
        const ALIANSPAY_EUR_VALUE = 650;
        const ALIANSPAY_USD_VALUE = 550; 
        const ALIANSPAY_MESSAGE_ERROR = 'An error has occured. Please try again later';
        const ALIANSPAY_SERVER_ADDRESS = '::1';
        const ALIANSPAY_API_CALLBACK_URL = 'checkStatus';
        const ALIANSPAY_PAYMENT_TEXT_BUTTON_OPTIONS = array(
            "pay"    => "Pay",
            "pay_now"  => "Pay Now",
            "mobile"  => "Pay with MoMo or OM",
            "card" => "Pay with Credit Card",
            "alianspay" => "Pay with AliansPay"
        );
        const ALIANSPAY_PAYMENT_IMAGE_OPTIONS = array(
            "all" => "all.png",
            "mobile"  => "momo_om.png",
            "credit_card"  => "visa_master_card.png",
        );

    
        /**
         * Constructor for the gateway.
         */
        public function __construct()
        {
            // The global ID for this Payment method
            $this->id = Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID;
 
            // Construction of the image to be displayed to the user
            $image_url = WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__)).'/images/'.
                                            Alianspay_Woocommerce_Gateway::ALIANSPAY_PAYMENT_IMAGE_OPTIONS[
                                                $this->get_option('payment_methods_image')
                                            ];

            // check if AliansPay icon image exists or not
            if (@getimagesize($image_url)) {
                //Show an image on the frontend
                $this->icon = $image_url;
            } else {
                //Show the name on the frontend
                $this->title = "AliansPay";
            }

            //button text used to perform the payment
            $this->order_button_text = __(
                Alianspay_Woocommerce_Gateway::ALIANSPAY_PAYMENT_TEXT_BUTTON_OPTIONS[$this->get_option('payment_button_text')],
                Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID);

            // Boolean. Can be set to true if you want payment fields to show on the checkout
            $this->has_fields = false;

            // The title of the payment method for the admin page
            $this->method_title =  __( 'AliansPay - Payment gateway for WooCommerce',Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID);

            // The description for this Payment Gateway, shown on the actual Payment options page on the backend
            $this->method_description =  __( 'AliansPay - Payment gateway for WooCommerce is a modern plugin that allows you to sell anywhere your customers are.
                                              Give yours customers the gift of mordern payment solution and let them pay you however they want by : 
                                              Orange Money, MTN Mobile Money, VISA, MASTER CARD and AliansPay wallet.', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID );

            // This basically defines your settings which are then loaded with init_settings()
            $this->init_form_fields();

            // After init_settings() is called, you can get the settings and load them into variables
            $this->init_settings();

            // Define user set variables
            $this->description  = $this->get_option( 'description' );
            
            // Used to perfom plugin information updated by the admin
            add_action( 'woocommerce_update_options_payment_gateways_' . 
                        $this->id, array( $this, 'process_admin_options' ) );

            //add_action( 'admin_enqueue_scripts', array( $this, 'admin_scripts' ) );

           

        }

    
        /**
         * Generate a callback url only one time
         * 
         * @return void
         */
        public function generate_callback_url(){
            
            $old_callback_url_value = $this->get_option( 'callback_url' );

            if($old_callback_url_value === ''){
                $genarate_callback_url = md5(uniqid().mt_rand());
                $site_address = get_home_url();
                $this->update_option( 'callback_url', $site_address.'/wp-json/callback/'.$genarate_callback_url);    
            }
        }

        /**
         * Initialize Gateway Settings Form Fields
         * 
         * @return void
         */
        public function init_form_fields() {

            //generate a callback url
            $this->generate_callback_url();

            $this->form_fields = apply_filters( 'alianspay_form_fields', array(

                'enabled' => array(
                    'title'   => __( 'Enable/Disable', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'    => 'checkbox',
                    'label'   => __( 'Enable AliansPay', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'description' => __('Check if you want to activate this plugin or uncheck if you want to disable
                                        this payment plugin ', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default' => 'yes',
                    'desc_tip'    => true,
                ),

                'description' => array(
                    'title'       => __( 'Description', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'textarea',
                    'description' => __( 'Payment method description that the customer will see on your checkout.',
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => __( 'Pay safely using Orange Money, Mtn Mobile Money, VISA, MASTER CARD, AliansPay wallet', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'desc_tip'    => true,
                    'custom_attributes' => array('readonly' => 'readonly'),
                ),

                'callback_url' => array(
                    'title'       => __( 'Callback url', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'textarea',
                    'description' => __( 'Copy this callback url and paste it in your AliansPay merchant account',
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => __( '', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'desc_tip'    => true,
                    'custom_attributes' => array('readonly' => 'readonly'),
                ),
                'payment_button_text' => array(
                    'title'       => __( 'Payment button text', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'select',
                    'description' => __( 'Text of the payment button on which the customer clicks to make the payment.',
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => __( 'pay', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'options'     => $this->get_payment_button_text_options(),
                    'desc_tip'    => true, 
                    'custom_attributes' => array('readonly' => 'readonly'),
                ),

                'payment_methods_image' => array(
                    'title'       => __( 'Enabled payment method', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'select',
                    'description' => __( 'choose the active payment method',
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => __( "all", 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'options'     => $this->get_payment_methods_options(),
                    'desc_tip'    => true, 
                    'custom_attributes' => array('readonly' => 'readonly'),
                ),

                'api_user_key' => array(
                    'title'       => __( 'Api User key', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'text',
                    'description' => __( 'This is the public key of your merchant service on AliansPay', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => '',
                    'desc_tip'    => true,
                ),
                'api_user_secret' => array(
                    'title'       => __( 'Api User Secret', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'text',
                    'description' => __( 'This is the public key of your merchant service on AliansPay', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => '',
                    'desc_tip'    => true,
                ),
                'api_user_guid' => array(
                    'title'       => __( 'Api User GUID', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'text',
                    'description' => __( 'This is the public key of your merchant service on AliansPay', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => '',
                    'desc_tip'    => true,
                ),
                'api_url' => array(
                    'title'       => __( 'API Url', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'type'        => 'text',
                    'description' => __( 'This is the public key of your merchant service on AliansPay', 
                                        Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID),
                    'default'     => '',
                    'desc_tip'    => true,
                ),
                
            ));
        }

        /**
         * callback url getter
         * 
         * @return void
         */
        public function get_callback_url(){
            /*$this->log('my url call '.$this->callback_url);
            $this->log('my second call '.$this->get_option( 'callback_url' ));
            return $this->callback_url;*/
            return $this->get_option( 'callback_url' );
        }
        
        /**
         * Payment button text getter
         * 
         * @return array $options
         */
        public function get_payment_button_text_options(){
            $options = array(
                "pay" => __( 'Pay', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "pay_now" => __( 'Pay Now', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "mobile" => __( 'Pay with MoMo or OM', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "card" => __( 'Pay with Credit Card', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "alianspay" => __( 'Pay with AliansPay', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
            );
            return $options;
        }

        /**
         *  Get Payment methods
         * 
         * @return array $options
         */
        public function get_payment_methods_options(){
            $options = array(
                "all" => __( "All", Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "mobile" => __( "Mobile (OM + MoMo)", Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
                "credit_card" => __( "Credit Card (VISA + MASTERCARD)", Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID), 
            );
            return $options;
        }
        

        /**
         * Convert order amount to XAF
         *
         * @param float $amount
         * @return int
         */
        public function convert_amount_to_fcfa($amount){
            
            $new_amount = 0;
            // Check  the woocommerce currency activated
            if(get_woocommerce_currency() ==='XAF' || get_woocommerce_currency() ==='XOF'){
                //Round up to the next number
                $new_amount = ceil($amount);
            }
            elseif (get_woocommerce_currency() ==='EUR'){
                $new_amount = ceil($amount * Alianspay_Woocommerce_Gateway::ALIANSPAY_EUR_VALUE) ;
            }
            elseif (get_woocommerce_currency() ==='USD'){
                $new_amount = ceil($amount * Alianspay_Woocommerce_Gateway::ALIANSPAY_USD_VALUE) ;
            }else{
                $new_amount = null;
            }
            return  $new_amount;
        }

         /**
         * Get the website language
         * 
         * @return string
         *
         */
        public function get_website_language(){
            // get the website language
             $lang = get_locale();
         
             if($lang === 'fr_FR' ){
                return 'fr';
             }else{
                return 'en';
             }
         }

        /**
         * This function handles the processing of the order, telling WooCommerce 
         * what status the order should have and where customers go after it’s used.
         * 
         * @param int $order_id
         * @return array
         *
         */
        public function process_payment( $order_id ) {
            
            $order = wc_get_order( $order_id );

            // get the order item's name
            foreach ($order->get_items() as $item_key => $item ){
                $order_items_name = $order_items_name.", ".$item->get_name();
            }
            //remove the comma  at the beginning of a string
            $order_items_name = preg_replace('/^,/', '', $order_items_name);
           
            //convert and get the total amount in fcfa
            $total_amount = $this->convert_amount_to_fcfa($order->order_total);  
           
            if($total_amount === null){
                wc_add_notice( __('Payment error : ', 'woothemes') . 
                                  "THIS CURRENCY IS NOT ALLOWED ON AliansPay", 'error' );
                return;
            }

            // get the website language
            $lang = $this->get_website_language();

            //building the url used to get the payment link
            $url = Alianspay_Woocommerce_Gateway::ALIANSPAY_API_BASE_URL.'/'.
                   $this->public_key.'/'.Alianspay_Woocommerce_Gateway::ALIANSPAY_API_LOGIN_URL;
            
            $request_parameters= [
                "transaction_amount"=> $total_amount,
                "transaction_reason"=> substr($order_items_name, 0, 40),
                "app_transaction_ref"=> $order->order_key,
                "customer_name"=>$order->billing_last_name.' '.$order->billing_first_name,
                "customer_email"=> $order->billing_email,
                "customer_lang"=>  $lang
            ];

            // getting the payment link
            //$response =  $this->get_payment_link($order, $url, $request_parameters);
            //return $response;
            
			include_once( 'alianspay-woocommerce-request.php' );
			$momo_request = new WC_Gateway_Request( $this );
            $token = $this->get_token();
            /*if($token === null){
                wc_add_notice( __('Payment error : ', 'woothemes') . 
                Alianspay_Woocommerce_Gateway::ALIANSPAY_MESSAGE_ERROR, 'error' );
                return;
            }*/

            $code = $this->get_googleAuth_code();
            if($code === null){
                wc_add_notice( __('Payment error : ', 'woothemes') . 
                Alianspay_Woocommerce_Gateway::ALIANSPAY_MESSAGE_ERROR, 'error' );
                return;
            }
                    
            $momo_request->code = $code;	
            $momo_request->token = $token;	
			return array(
				'result'   => 'success',
				'redirect' => $momo_request->get_request_url( $order ),
			);
        }
		
		public function get_token(){
            
			$url = Alianspay_Woocommerce_Gateway::ALIANSPAY_API_BASE_URL.'/'.Alianspay_Woocommerce_Gateway::ALIANSPAY_API_LOGIN_URL;
            
            $body = wp_json_encode( array(
                            "login" => $this->get_option( 'api_user_key' ),
                            "password" => $this->get_option( 'api_user_secret' ),
                            ));

            $request = wp_remote_post( $url, array(
                            'method'    => 'POST',
                            'sslverify' => FALSE,
                            'headers'   => [
                                'Content-Type' => 'application/json',
                            ],
                            'body' => $body
                            ));

            $response = json_decode(wp_remote_retrieve_body($request), true);
            $keyLogin = array_keys($response);
			if(in_array("statusMessage", $keyLogin)){
				if($response["statusMessage"] === "SUCCESS"){
					$result = $response["object"];
                    $this->log("Token: ".$result["access_token"]);
                    return $result["access_token"];
				}
				else{
					wc_add_notice( __('Payment error : ', 'woothemes'). Alianspay_Woocommerce_Gateway::ALIANSPAY_MESSAGE_ERROR, 'error' );
					return;
				}
			}
			else{
				wc_add_notice( __('Payment error : ', 'woothemes'). Alianspay_Woocommerce_Gateway::ALIANSPAY_MESSAGE_ERROR, 'error' );
                return;
			}
		}
		
		public function get_googleAuth_code(){
             
             //$otp = new TOTP();//::create($this->get_option( 'api_user_guid' ));
			 /*$oneCode = $otp->now();
             $this->log("Code: ".$oneCode);
             return $oneCode;*/
             
             
             /*$ga = new GoogleAuthenticator();
             $oneCode = $ga->getCode($this->get_option( 'api_user_guid' ));
             $this->log("Code: ".$oneCode);
             return $oneCode;*/
			 
			 $ga = new AliansGoogleAuthenticator();
             $pin = $ga->getCode($this->get_option( 'api_user_guid' ));
			 return $pin;
		}


         /**
         * Used to get the payment link from AliansPay
         * 
         * @param array $order
         * @param string $url
         * @param string $request_parameters
         * @return array
         *
         */
        public function get_payment_link($order, $url, $request_parameters){

            global $woocommerce;
                                
            $request = wp_remote_post($url, array(
                'body' => $request_parameters
            ));

            $body = wp_remote_retrieve_body($request);

            $result = json_decode($body, true);

            if(isset($result["status"])){
                if($result["status"] === "success"){
                    if (isset($result["payment_url"])){
                        
                        $order->update_status( 'on-hold', __( 'Awaiting confirmation of payment', Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID) );

                        // Remove cart
                        $woocommerce->cart->empty_cart();

                        $response = [
                            'result'    => 'success',
                            'redirect'  => $result['payment_url'] 
                        ];

                       return $response;
                    }
                }
                else if ($result["status"] === "error"){
                    if (isset($result["message"])){
                        wc_add_notice( __('Payment error : ', 'woothemes') . $result["message"], 'error' );
                        return;
                    }
                }
            }else{
                wc_add_notice( __('Payment error : ', 'woothemes'). Alianspay_Woocommerce_Gateway::ALIANSPAY_MESSAGE_ERROR, 'error' );
                return;
            }
        }
		
		public static function log( $message, $level = 'info' ) {
			$logger = wc_get_logger();
			$logger->log( $level, $message, array( 'source' => Alianspay_Woocommerce_Gateway::ALIANSPAY_GATEWAY_ID ) );
		}

        /**
	 * Load admin scripts.
	 *
	 * @since 3.3.0
	 */
	/*public function admin_scripts() {
        wp_localize_script( 'ajax-script', 'ajax_object',
            array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'we_value' => 1234 ) );
		$screen    = get_current_screen();
		$screen_id = $screen ? $screen->id: '';

	

		$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

		wp_enqueue_script( 'woocommerce_alianspay_admin', WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__)).'/include/'.'jquery.min.js', array(), WC_VERSION, true );
	}*/
    }    
}
   
    /* ============================================ INCLUDE OTHER FILE =========================================== */

    //including the callback 
    include 'include/alianspay_callback.php';
    // including the order_key in wc admin order list
    include 'include/alianspay_update_wc_admin_order_list.php';
	
	include 'include/GoogleAuthenticator.php';
	include 'include/libs/AliansGoogleAuthenticator.php';
    
    
    
    /*=========================================================================================================== */
    //wp_enqueue_script( 'tt-mobile-menu', WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__)).'/include/' .'jquery.min.js', array('jquery'), '1.0', true );
}





